module memory(
    input logic fast_clk,
    input logic wr,
    input logic rd,
    input logic [11:0] wr_data,
    input logic [7:0] addr,
    input logic [7:0] wr_addr,
    output logic [11:0] rd_data,
    output logic [11:0] data
    );
    
    integer i;
     reg [11:0] memory_all_bit [254:0];
    
    initial begin
        i <= 0;
        //saved
        memory_all_bit[0] <= 12'h200;
        memory_all_bit[1] <= 12'h200;
        //setup
        memory_all_bit[2] <= 12'h200;
        memory_all_bit[3] <= 12'h240;
        memory_all_bit[4] <= 12'h240;
        memory_all_bit[5] <= 12'h240;
        memory_all_bit[6] <= 12'h240;
        memory_all_bit[7] <= 12'h200;
        memory_all_bit[8] <= 12'h200;
        memory_all_bit[9] <= 12'h200;
        memory_all_bit[10] <= 12'h280;
        memory_all_bit[11] <= 12'h280;
        memory_all_bit[12] <= 12'h280;
        memory_all_bit[13] <= 12'h280;
        memory_all_bit[14] <= 12'h200;
        memory_all_bit[15] <= 12'h200;
        memory_all_bit[16] <= 12'h200;
        memory_all_bit[17] <= 12'h200;
        memory_all_bit[18] <= 12'h204;
        memory_all_bit[19] <= 12'h204;
        memory_all_bit[20] <= 12'h204;
        memory_all_bit[21] <= 12'h204;
        memory_all_bit[22] <= 12'h204;
        memory_all_bit[23] <= 12'h204;
        memory_all_bit[24] <= 12'h204;
        memory_all_bit[25] <= 12'h204;
        memory_all_bit[26] <= 12'h204;
        
        memory_all_bit[27] <= 12'h403;  //loop start, repeat=3
        //sample
        memory_all_bit[28] <= 12'h204;
        memory_all_bit[29] <= 12'h204;
        memory_all_bit[30] <= 12'h224;
        memory_all_bit[31] <= 12'h224;
        memory_all_bit[32] <= 12'h224;
        memory_all_bit[33] <= 12'h224;
        memory_all_bit[34] <= 12'h224;
        memory_all_bit[35] <= 12'h224;
        memory_all_bit[36] <= 12'h224;
        memory_all_bit[37] <= 12'h224;
        memory_all_bit[38] <= 12'h224;
        memory_all_bit[39] <= 12'h224;
        memory_all_bit[40] <= 12'h224;
        memory_all_bit[41] <= 12'h204;
        memory_all_bit[42] <= 12'h20C;
        memory_all_bit[43] <= 12'h20C;
        memory_all_bit[44] <= 12'h20C;
        memory_all_bit[45] <= 12'h20C;
        memory_all_bit[46] <= 12'h20C;
        memory_all_bit[47] <= 12'h20C;
        memory_all_bit[48] <= 12'h20C;
        memory_all_bit[49] <= 12'h20C;
        memory_all_bit[50] <= 12'h20C;
        memory_all_bit[51] <= 12'h20E;
        memory_all_bit[52] <= 12'h20E;
        memory_all_bit[53] <= 12'h20E;
        memory_all_bit[54] <= 12'h20C;
        memory_all_bit[55] <= 12'h204; 
        memory_all_bit[56] <= 12'h204; 
        memory_all_bit[57] <= 12'h204;
        memory_all_bit[58] <= 12'h204;
        memory_all_bit[59] <= 12'h204;
        memory_all_bit[60] <= 12'h204;
        memory_all_bit[61] <= 12'h204;
        memory_all_bit[62] <= 12'h204;
        memory_all_bit[63] <= 12'h204;
        memory_all_bit[64] <= 12'h204;
        memory_all_bit[65] <= 12'h204;
        memory_all_bit[66] <= 12'h204;
        memory_all_bit[67] <= 12'h204;
        memory_all_bit[68] <= 12'h204;
        memory_all_bit[69] <= 12'h204;
        memory_all_bit[70] <= 12'h204;
        memory_all_bit[71] <= 12'h204;
        memory_all_bit[72] <= 12'h204;
        memory_all_bit[73] <= 12'h204;
        memory_all_bit[74] <= 12'h204;
        memory_all_bit[75] <= 12'h204;
        memory_all_bit[76] <= 12'h204;
        memory_all_bit[77] <= 12'h204;
        memory_all_bit[78] <= 12'h204;
        memory_all_bit[79] <= 12'h204;
        memory_all_bit[80] <= 12'h204;
        memory_all_bit[81] <= 12'h204;
        memory_all_bit[82] <= 12'h204;
        memory_all_bit[83] <= 12'h204;
        memory_all_bit[84] <= 12'h204;
        memory_all_bit[85] <= 12'h20C;
        memory_all_bit[86] <= 12'h20C;
        memory_all_bit[87] <= 12'h21C;
        memory_all_bit[88] <= 12'h21C;
        memory_all_bit[89] <= 12'h21C;
        memory_all_bit[90] <= 12'h21C;
        memory_all_bit[91] <= 12'h21C;
        memory_all_bit[92] <= 12'h21C;
        memory_all_bit[93] <= 12'h21C;
        memory_all_bit[94] <= 12'h21D;
        memory_all_bit[95] <= 12'h21D;
        memory_all_bit[96] <= 12'h21D;
        memory_all_bit[97] <= 12'h21C;
        memory_all_bit[98] <= 12'h204;
        memory_all_bit[99] <= 12'h204;
        memory_all_bit[100] <= 12'h200;
        memory_all_bit[101] <= 12'h200;
        memory_all_bit[102] <= 12'h200;
        memory_all_bit[103] <= 12'h240;
        memory_all_bit[104] <= 12'h240;
        memory_all_bit[105] <= 12'h240;
        memory_all_bit[106] <= 12'h240;
        memory_all_bit[107] <= 12'h200;
        memory_all_bit[108] <= 12'h200;
        memory_all_bit[109] <= 12'h200;
        memory_all_bit[110] <= 12'h200;
        memory_all_bit[111] <= 12'h200;
        
        memory_all_bit[112] <= 12'h51C; //loop stop, return to 28
        //shutter
        memory_all_bit[113] <= 12'h200;
        memory_all_bit[114] <= 12'h200;
        memory_all_bit[115] <= 12'h200;
        memory_all_bit[116] <= 12'h280;
        memory_all_bit[117] <= 12'h280;
        memory_all_bit[118] <= 12'h280;
        memory_all_bit[119] <= 12'h280;
        memory_all_bit[120] <= 12'h200;
        memory_all_bit[121] <= 12'h200;
        memory_all_bit[122] <= 12'h200;
        memory_all_bit[123] <= 12'h200;
        memory_all_bit[124] <= 12'h220;
        memory_all_bit[125] <= 12'h220;
        memory_all_bit[126] <= 12'h230;
        memory_all_bit[127] <= 12'h230;
        memory_all_bit[128] <= 12'h230;
        memory_all_bit[129] <= 12'h230;
        memory_all_bit[130] <= 12'h230;
        memory_all_bit[131] <= 12'h230;
        memory_all_bit[132] <= 12'h230;
        memory_all_bit[133] <= 12'h220;
        memory_all_bit[134] <= 12'h220;
        memory_all_bit[135] <= 12'h200;
        memory_all_bit[136] <= 12'h200;
        memory_all_bit[137] <= 12'h200;
        memory_all_bit[138] <= 12'h200;
        memory_all_bit[139] <= 12'h200;
        memory_all_bit[140] <= 12'h200;
        memory_all_bit[141] <= 12'h200;
        memory_all_bit[142] <= 12'h200;
        memory_all_bit[143] <= 12'h200;
        memory_all_bit[144] <= 12'h200;
        memory_all_bit[145] <= 12'h200;
        memory_all_bit[146] <= 12'h200;
        memory_all_bit[147] <= 12'h200;
        memory_all_bit[148] <= 12'h200;
        memory_all_bit[149] <= 12'h200;
        memory_all_bit[150] <= 12'h200;
        memory_all_bit[151] <= 12'h200;
        memory_all_bit[152] <= 12'h200;
        memory_all_bit[153] <= 12'h200;
        memory_all_bit[154] <= 12'h200;
        memory_all_bit[155] <= 12'h200;
        
    end
    
    always @ (posedge fast_clk) begin
        data <= memory_all_bit[addr];
        
        if(wr)
            memory_all_bit[wr_addr] <= wr_data;
        if(rd) begin
            rd_data <= memory_all_bit[i];
            if(i==254)
                i = 0;
            else
                i = i + 1;
        end 
    end
endmodule
