`timescale 1 ns/10 ps

module top_tb();
    //logic clk;
    logic fast_clk;
    logic rst_n;
    logic[7:0] outwave;
    integer i;
    
    top test1(.clk_in(fast_clk), .rst_n(rst_n), .outwave(outwave));
    
    initial begin 
        rst_n = 0;
        fast_clk = 0; #5;
        fast_clk = 1; #5;
        rst_n = 1;
        for (i=0; i<8; i++) begin
            fast_clk = 0; #5;
            fast_clk = 1; #5;
        end
        rst_n = 1;
        for (i=0; i<500; i++) begin
            fast_clk = 0; #5;
            fast_clk = 1; #5;

        end
        $finish;
    end

endmodule