module memory(
    input logic fast_clk,
    input logic wr,
    input logic rd,
    input logic [7:0] wr_data,
    input logic [7:0] addr,
    input logic [7:0] wr_addr,
    output logic [7:0] rd_data,
    output logic [7:0] data
    );
    
    integer i;
     reg [7:0] memory_all_bit [254:0];
    
    initial begin
        i <= 0;
        //saved
        memory_all_bit[0] <= 8'h43; //loop start part 1
        memory_all_bit[1] <= 8'h50; //loop start part 2
        //setup
        memory_all_bit[2] <= 8'h30;
        memory_all_bit[3] <= 8'h26;
        memory_all_bit[4] <= 8'h30;
        memory_all_bit[5] <= 8'h30;
        memory_all_bit[6] <= 8'h30;
        memory_all_bit[7] <= 8'h26;
        memory_all_bit[8] <= 8'h30;
        memory_all_bit[9] <= 8'h30;
        memory_all_bit[10] <= 8'h27;
        memory_all_bit[11] <= 8'h30;
        memory_all_bit[12] <= 8'h30;
        memory_all_bit[13] <= 8'h30;
        memory_all_bit[14] <= 8'h27;
        memory_all_bit[15] <= 8'h30;
        memory_all_bit[16] <= 8'h30;
        memory_all_bit[17] <= 8'h30;
        memory_all_bit[18] <= 8'h22;
        memory_all_bit[19] <= 8'h30;
        memory_all_bit[20] <= 8'h30;
        memory_all_bit[21] <= 8'h30;
        memory_all_bit[22] <= 8'h30;
        memory_all_bit[23] <= 8'h30;
        memory_all_bit[24] <= 8'h30;
        memory_all_bit[25] <= 8'h30;
        memory_all_bit[26] <= 8'h30;
        
        
        memory_all_bit[27] <= 8'h43; //loop start part 1
        memory_all_bit[28] <= 8'h50; //loop start part 2
        
        //sample
        memory_all_bit[29] <= 8'h30;
        memory_all_bit[30] <= 8'h30;
        memory_all_bit[31] <= 8'h22;
        memory_all_bit[32] <= 8'h30;
        memory_all_bit[33] <= 8'h30;
        memory_all_bit[34] <= 8'h30;
        memory_all_bit[35] <= 8'h30;
        memory_all_bit[36] <= 8'h30;
        memory_all_bit[37] <= 8'h30;
        memory_all_bit[38] <= 8'h30;
        memory_all_bit[39] <= 8'h30;
        memory_all_bit[40] <= 8'h30;
        memory_all_bit[41] <= 8'h30;
        memory_all_bit[42] <= 8'h30;
        memory_all_bit[43] <= 8'h22;
        memory_all_bit[44] <= 8'h24;
        memory_all_bit[45] <= 8'h30;
        memory_all_bit[46] <= 8'h30;
        memory_all_bit[47] <= 8'h30;
        memory_all_bit[48] <= 8'h30;
        memory_all_bit[49] <= 8'h30;
        memory_all_bit[50] <= 8'h30;
        memory_all_bit[51] <= 8'h30;
        memory_all_bit[52] <= 8'h30;
        memory_all_bit[53] <= 8'h30;
        memory_all_bit[54] <= 8'h26;
        memory_all_bit[55] <= 8'h30;
        memory_all_bit[56] <= 8'h30;
        memory_all_bit[57] <= 8'h26;
        memory_all_bit[58] <= 8'h24;
        memory_all_bit[59] <= 8'h30;
        memory_all_bit[60] <= 8'h30;
        memory_all_bit[61] <= 8'h30;
        memory_all_bit[62] <= 8'h30;
        memory_all_bit[63] <= 8'h30;
        memory_all_bit[64] <= 8'h30;
        memory_all_bit[65] <= 8'h30;
        memory_all_bit[66] <= 8'h30;
        memory_all_bit[67] <= 8'h30;
        memory_all_bit[68] <= 8'h30;
        memory_all_bit[69] <= 8'h30;
        memory_all_bit[70] <= 8'h30;
        memory_all_bit[71] <= 8'h30;
        memory_all_bit[72] <= 8'h30;
        memory_all_bit[73] <= 8'h30;
        memory_all_bit[74] <= 8'h30;
        memory_all_bit[75] <= 8'h30;
        memory_all_bit[76] <= 8'h30;
        memory_all_bit[77] <= 8'h30;
        memory_all_bit[78] <= 8'h30;
        memory_all_bit[79] <= 8'h30;
        memory_all_bit[80] <= 8'h30;
        memory_all_bit[81] <= 8'h30;
        memory_all_bit[82] <= 8'h30;
        memory_all_bit[83] <= 8'h30;
        memory_all_bit[84] <= 8'h30;
        memory_all_bit[85] <= 8'h30;
        memory_all_bit[86] <= 8'h30;
        memory_all_bit[87] <= 8'h30;
        memory_all_bit[88] <= 8'h24;
        memory_all_bit[89] <= 8'h30;
        memory_all_bit[90] <= 8'h23;
        memory_all_bit[91] <= 8'h30;
        memory_all_bit[92] <= 8'h30;
        memory_all_bit[93] <= 8'h30;
        memory_all_bit[94] <= 8'h30;
        memory_all_bit[95] <= 8'h30;
        memory_all_bit[96] <= 8'h30;
        memory_all_bit[97] <= 8'h27;
        memory_all_bit[98] <= 8'h30;
        memory_all_bit[99] <= 8'h30;
        memory_all_bit[100] <= 8'h27;
        memory_all_bit[101] <= 8'h13;
        memory_all_bit[102] <= 8'h24;
        memory_all_bit[103] <= 8'h30;
        memory_all_bit[104] <= 8'h25;
        memory_all_bit[105] <= 8'h30;
        memory_all_bit[106] <= 8'h30;
        memory_all_bit[107] <= 8'h21;
        memory_all_bit[108] <= 8'h30;
        memory_all_bit[109] <= 8'h30;
        memory_all_bit[110] <= 8'h30;
        memory_all_bit[111] <= 8'h21;
        memory_all_bit[112] <= 8'h30;
        memory_all_bit[113] <= 8'h30;
        memory_all_bit[114] <= 8'h30;
        memory_all_bit[115] <= 8'h30;
        
        memory_all_bit[116] <= 8'h25;  //correction to enable loop
        memory_all_bit[117] <= 8'h69;  //loop end part 1, addr 0x29
        memory_all_bit[118] <= 8'h72;  //loop end part 2, addr 0x29
        memory_all_bit[119] <= 8'h25;  //correction to go out of loop
        
        //shutter 
        memory_all_bit[120] <= 8'h30;
        memory_all_bit[121] <= 8'h30;
        memory_all_bit[122] <= 8'h30;
        memory_all_bit[123] <= 8'h20;
        memory_all_bit[124] <= 8'h30;
        memory_all_bit[125] <= 8'h30;
        memory_all_bit[126] <= 8'h30;
        memory_all_bit[127] <= 8'h20;
        memory_all_bit[128] <= 8'h30;
        memory_all_bit[129] <= 8'h30;
        memory_all_bit[130] <= 8'h30;
        memory_all_bit[131] <= 8'h22;
        memory_all_bit[132] <= 8'h30;
        memory_all_bit[133] <= 8'h23;
        memory_all_bit[134] <= 8'h30;
        memory_all_bit[135] <= 8'h30;
        memory_all_bit[136] <= 8'h30;
        memory_all_bit[137] <= 8'h30;
        memory_all_bit[138] <= 8'h30;
        memory_all_bit[139] <= 8'h30;
        memory_all_bit[140] <= 8'h23;
        memory_all_bit[141] <= 8'h30;
        memory_all_bit[142] <= 8'h22;
        memory_all_bit[143] <= 8'h30;
        memory_all_bit[144] <= 8'h30;
        memory_all_bit[145] <= 8'h30;
        memory_all_bit[146] <= 8'h30;
        memory_all_bit[147] <= 8'h30;
        memory_all_bit[148] <= 8'h30;
        memory_all_bit[149] <= 8'h30;
        memory_all_bit[150] <= 8'h30;
        memory_all_bit[151] <= 8'h30;
        memory_all_bit[152] <= 8'h30;
        memory_all_bit[153] <= 8'h30;
        memory_all_bit[154] <= 8'h30;
        memory_all_bit[155] <= 8'h30;
        memory_all_bit[156] <= 8'h30;
        memory_all_bit[157] <= 8'h30;
        memory_all_bit[158] <= 8'h30;
        memory_all_bit[159] <= 8'h30;
        memory_all_bit[160] <= 8'h30;
        memory_all_bit[161] <= 8'h30;
        memory_all_bit[162] <= 8'h30;
        
    end
    
    always @ (posedge fast_clk) begin
        data <= memory_all_bit[addr];
        
        /*if(wr)
            memory_all_bit[wr_addr] <= wr_data;
        if(rd) begin
            rd_data <= memory_all_bit[i];
            if(i==254)
                i = 0;
            else
                i = i + 1;
        end */
    end
endmodule
